"use strict";
this.name = "oolite-random-hits-bigboss";
this.author = "LittleBear";
this.copyright = "March 2009 - But do what you like with it in your OXPs!";
this.description	= "Gives Big Boss Criminals an indiviual name on the ID computer and sets them to the right AI."
this.licence     = "CC BY-NC-SA 3.0";
this.version = "2.4";

this.shipSpawned = function ()
{
    //this.ship.name = "Big Boss";
	this.ship.displayName = this.ship.name + ": " + expandDescription("[random_hits_bigboss_name]"); // Show the Criminal's name on the ID Computer when targeted.
    this.ship.bounty += Math.random()*400+73;

	//log("rh", "boss:"+this.ship.displayName);

    delete this.shipSpawned;
};


this.shipBeingAttacked = function (who)
{
    if (!who) return;
    if (who.roles.indexOf("bigBos_revenge_clan") > -1) 
    {
        this.ship.reactToAIMessage("FRIENDLY_FIRE");
        return;		
    }

    if (who.primaryRole === "random_hits_spacebar") 
    {
        this.ship.reactToAIMessage("SPACEBAR_ATTACK");
        return;		
    }

	// The AIs of criminals do not react to the nomal "ATTACKED" message, only this special one. They therefore ignore attacks by their own side.	
	this.ship.reactToAIMessage("ENEMY_ATTACK"); 
};

this.shipDied = function (whom)
{
    missionVariables.random_hits_total_boss_kills++;
    this.ship.commsMessage(expandDescription("[random_hits_criminal_curses]"));
    
    if (whom && whom.isPlayer)
	{
        missionVariables.random_hits_criminal_hate_score += 4;
        missionVariables.random_hits_criminal_kill_score++;
        missionVariables.random_hits_total_player_boss_kills++;
	}
    this.broadcastBigBossCount();
};

this.shipWillEnterWormhole = function ()
{
    this.broadcastBigBossCount();
};

this.broadcastBigBossCount = function ()
{
    // sets variables in the main script + display messages when needed.
    worldScripts["Random_Hits"].broadcastBigBossCount();
};

this.doScan = function () 
{ 
	// create an array with all ships (exclude barrels and rocks) 
	function allShips(entity) {return entity.isShip && entity.scanClass !== "CLASS_ROCK" && entity.scanClass !== "CLASS_CARGO"}; 
	var anyShips = system.filteredEntities(this, allShips, this.ship, this.ship.scannerRange);
    
    // anyShips now holds all real ships in scanner range. From now only analyse this small list further to save time.
    
    // Unlike AI scans, this scan already sets the target. So don't use "setTargetToFoundTarget" because the foundTarget
    // could be something completely unexpected that was left behind from a previous scan.

	// do player first.
	function isPlayer(entity) {return entity.isPlayer}; 
    var playerPresent = (anyShips.filter(isPlayer).length > 0);
    if (playerPresent && Math.random()>0.66) //find the player in 1 out of 3 scans
    {
        this.ship.target = player.ship;
        this.ship.reactToAIMessage("CLEAN_SHIP_FOUND"); // player needs not to be clean to be found.
        return;
    }

	// do clean ships when no player found.
	function cleanShips(entity) {return entity.bounty === 0};
    var cleans = anyShips.filter(cleanShips); 
    if (cleans.length > 0){
        this.ship.target = cleans[Math.floor(Math.random()*cleans.length)];
        this.ship.reactToAIMessage("CLEAN_SHIP_FOUND");
    } else {
        this.ship.reactToAIMessage("NOTHING_FOUND");
    }
};
