"use strict";
this.name = "oolite-random-hits-guard";
this.author = "LittleBear";
this.copyright = "September 2008 - But do what you like with it in your OXPs!";
this.description	= "Gives each of a Mark's Guards an indiviual name on the ID computer, sets them to the right AI and stops a kill of an escort being treated as a kill of the Mark.";
this.licence     = "CC BY-NC-SA 3.0";
this.version = "2.4";

this.shipSpawned = function ()
{
    //this.ship.name = "Mark escort";
	this.ship.displayName = this.ship.name + ": " + expandDescription("[random_hits_guard_name]");
    this.ship.bounty += Math.ceil(Math.random()*10);
    this.leader = this.ship.group.leader.displayName;
    delete this.shipSpawned;
};

this.shipBeingAttacked = function (whom)
{
    if (missionVariables.random_hits_status === "RUNNING")
    {
        /* As the Mark and his escorts are all part of the same group the game will regard an attack on an escort as an
        attack on the Mark. To get round this an attack on an escort ship resets the variable. Only an attack on the
        Mark himself will therefore cause the variable to be set. The ships still act as a group and defend each other.
        Shooting the ship after the leader died has no effect.
        */
        if (this.ship.group && this.ship.group.leader)
        {
            this.ship.group.leader.script.random_hits_whoshot = "NPC_ATTACK";
        }
    }
};

this.playerWillEnterWitchspace = function (){
    if (missionVariables.random_hits_status === "COMPLETE"){
        // player jumped to another system while the leader or its pod is killed but the guard is not.
        log(this.name, "The mark escort with name: "+this.ship.displayName+" wants to say that the player killed his boss: "+this.leader);
        missionVariables.random_hits_criminal_hate_score += 2; // player left withness of the kill behind.
    }
};
